
#include <iostream>
#include <ell/RNAFreeEnergy.hh>


int main(int argc, char **argv) {

	using namespace ell;

	std::cout	<<"========== BEGIN OF TEST =================\n"
				<<" test class : RNAFreeEnergy\n"
				<<"==========================================" <<std::endl;

		std::string seqStr = "GGCAAAGUCAAAGAU";
	std::cout	<<"=> " <<seqStr <<" = seqStr" <<std::endl;
		std::string structStr = "..(...).(...)..";
	std::cout	<<"=> " <<structStr <<" = structStr" <<std::endl;
	std::cout	<<"=> create ell::RNAFreeEnergy(seqStr, structStr)" 
				<<std::endl;
		ell::RNAFreeEnergy rnaStruct(seqStr, structStr);

		// ==
	std::cout	<<"->(*this == *this)  = "
				<<(rnaStruct == rnaStruct ?"true":"false")
				<<std::endl;

		// !=
	std::cout	<<"->(*this != *this)  = "
				<<(rnaStruct == rnaStruct ?"true":"false")
				<<std::endl;

		// hasValidStructure()
	std::cout	<<"->hasValidStructure()  = "
				<<(rnaStruct.hasValidStructure() ? "true":"false")
				<<std::endl;

		// hasValidBasePairs()
	std::cout	<<"->hasValidBasePairs()  = "
				<<(rnaStruct.hasValidBasePairs() ? "true":"false")
				<<std::endl;

		// getMinLoopLength()
	std::cout	<<"->getMinLoopLength()  = "
				<<rnaStruct.getMinLoopLength()
				<<std::endl;

		// hasMinLoopLength()
	std::cout	<<"->hasMinLoopLength()  = "
				<<(rnaStruct.hasMinLoopLength() ? "true":"false")
				<<std::endl;

		// isAllowedBasePair() = false
	std::cout	<<"->isAllowedBasePair(0,4)  = "
				<<(rnaStruct.isAllowedBasePair(0,4) ? "true":"false")
				<<std::endl;

		// isAllowedBasePair() = false
	std::cout	<<"->isAllowedBasePair(INVALID_INDEX,4)  = "
				<<(rnaStruct.isAllowedBasePair(RNAStructure::INVALID_INDEX,4) ?
						"true":"false")
				<<std::endl;

		// isAllowedBasePair() = true
	std::cout	<<"->isAllowedBasePair(1,7)  = "
				<<(rnaStruct.isAllowedBasePair(1,7) ? "true":"false")
				<<std::endl;

		// getClosingBond(2)
	std::cout	<<"->getClosingBond(2)  = "
				<<rnaStruct.getClosingBond(2)
				<<std::endl;

		// getClosingBond(3)
	std::cout	<<"->getClosingBond(3)  == INVALID_INDEX "
				<< ( rnaStruct.getClosingBond(3)== RNAStructure::INVALID_INDEX
					 ? "true":"false")
				<<std::endl;

		// getSequenceString()
	std::cout	<<"->RNAFreeEnergy::getSequenceString() = "
				<<rnaStruct.getSequenceString()
				<<std::endl;

		// getStructureString()
	std::cout	<<"->RNAFreeEnergy::getStructureString() = "
				<<rnaStruct.getStructureString()
				<<std::endl;

		// getSequence()
	std::cout	<<"->RNAFreeEnergy::getSequenceAlphabet()->getString("
				<<" rnaStruct.getSequence())  = "
				<<RNAFreeEnergy::getSequenceAlphabet()
				   ->getString(rnaStruct.getSequence())
				<<std::endl;
	std::cout	<<"->RNAFreeEnergy::getSequenceAlphabet()->getString("
				<<" rnaStruct.getSequence()) == seqStr)  = "
				<<(RNAFreeEnergy::getSequenceAlphabet()
				   ->getString(rnaStruct.getSequence()) == seqStr ? 
						"true":"false")
				<<std::endl;

		// getStructure()
	std::cout	<<"->RNAFreeEnergy::getStructureAlphabet()->getString("
				<<" rnaStruct.getStructure()  = "
				<<RNAFreeEnergy::getStructureAlphabet()
				  ->getString(rnaStruct.getStructure())
				<<std::endl;
	std::cout	<<"->(RNA::FreeEnergy::getStructureAlphabet()>getString("
				<<" rnaStruct.getStructure()) == structStr)  = "
				<<(RNAFreeEnergy::getStructureAlphabet()
				  ->getString(rnaStruct.getStructure()) == structStr ? 
						"true":"false")
				<<std::endl;

		// isValid()
	std::cout	<<"->isValid()  = "
				<<(rnaStruct.isValid() ? "true":"false")
				<<std::endl;

		// getStringRepresentation()
	std::cout	<<"->getStringRepresentation()  = "
				<<rnaStruct.getStringRepresentation()
				<<std::endl;

		// getEnergy()
	std::cout	<<"->getEnergy()  = "
				<<rnaStruct.getEnergy()
				<<std::endl;

	RNAFreeEnergy::SingleMove s15(1,5);
	std::cout	<<"=> creating SingleMove (" 
				<<s15.first <<","<<s15.second <<") = s15"
				<<std::endl;
	RNAFreeEnergy::SingleMove s17(1,7);
	std::cout	<<"=> creating SingleMove (" 
				<<s17.first <<","<<s17.second <<") = s17"
				<<std::endl;
				
		// isValidSingleMove() == false
	std::cout	<<"->isValidSingleMove(s15)  = "
				<<(rnaStruct.isValidSingleMove(s15) ?"true":"false")
				<<std::endl;

		// isValidSingleMove() == true
	std::cout	<<"->isValidSingleMove(s17)  = "
				<<(rnaStruct.isValidSingleMove(s17) ?"true":"false")
				<<std::endl;

		// ->getStructureString()
	std::cout	<<"->getStructureString()  = "
				<<rnaStruct.getStructureString()
				<<std::endl;

		// applySingleMoveInPlace()
	std::cout	<<"->applySingleMoveInPlace(s17)" <<std::endl;
		rnaStruct.applySingleMoveInPlace(s17);

		// getStructureString()
	std::cout	<<"->getStructureString()  = "
				<<rnaStruct.getStructureString()
				<<std::endl;

		// nextCompatibleSingleMovePos(0)
	std::cout	<<"->nextCompatibleSingleMovePos(0)  = "
				<<rnaStruct.nextCompatibleSingleMovePos(0)
				<<std::endl;

	std::cout	<<"============= END OF TEST ================\n" <<std::endl;
	
	return 0;
}
